/* TreeInfoDialog.java
 *
 *  Copyright (C) 2002-2007
 *  ASTRON (Netherlands Foundation for Research in Astronomy)
 *  P.O.Box 2, 7990 AA Dwingeloo, The Netherlands, softwaresupport@astron.nl
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package nl.astron.lofar.sas.otbcomponents;
import java.awt.Color;
import nl.astron.lofar.lofarutils.LofarUtils;
import nl.astron.lofar.sas.otb.MainFrame;
import org.apache.log4j.Logger;


/**
 *
 * @created 24-03-2006, 12:34
 *
 * @author  coolen
 *
 * @version $Id: TreeInfoDialog.java 16103 2010-07-30 11:01:55Z coolen $
 */
public class CoordConversionDialog extends javax.swing.JDialog {
    static Logger logger = Logger.getLogger(CoordConversionDialog.class);
    static String name = "TreeInfoDialog";
    
    /** Creates new form BeanForm
     * 
     * @param   parent      Frame where this dialog belongs
     * @param   modal       Should the Dialog be modal or not
     * @param   aTree       the Tree we work with
     * @param   aMainFrame  the Mainframe we are part off
     */
    public CoordConversionDialog(MainFrame aMainFrame) {
        super(aMainFrame);
        initComponents();
        itsMainFrame = aMainFrame;

        init();        
    }

    
  
    private void init() {


        isInitialized=false;
        topLabel.setText("Coordinate Conversion Tool");

        isInitialized=true;
 
    }
  
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        topLabel = new javax.swing.JTextArea();
        cancelButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        radianInput = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        minuteInput = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        degreesInput = new javax.swing.JTextField();
        clearFieldsButton = new javax.swing.JButton();
        degreesDMSInput = new javax.swing.JTextField();
        momIDLabel1 = new javax.swing.JLabel();
        secondInput = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        convertFromInput = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        hourInput = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        minuteDMSInput = new javax.swing.JTextField();
        momIDLabel2 = new javax.swing.JLabel();
        secondDMSInput = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Coordinate Conversions");
        setName("loadFileDialog"); // NOI18N
        setResizable(false);

        topLabel.setColumns(20);
        topLabel.setEditable(false);
        topLabel.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        topLabel.setRows(2);
        topLabel.setText("Coordinate Conversions");
        topLabel.setOpaque(false);

        cancelButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/nl/astron/lofar/sas/otb/icons/16_cancel.png"))); // NOI18N
        cancelButton.setText("Cancel");
        cancelButton.setToolTipText("Cancel filesearch");
        cancelButton.setAlignmentX(0.5F);
        cancelButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jLabel1.setText("Hours:");
        jLabel1.setAlignmentX(0.5F);

        jLabel6.setText("Radians:");
        jLabel6.setAlignmentX(0.5F);

        radianInput.setToolTipText("Radians");

        jLabel3.setText("Minutes:");
        jLabel3.setAlignmentX(0.5F);

        minuteInput.setToolTipText("Minutes in HMS notation");

        jLabel10.setText("Degrees:");
        jLabel10.setAlignmentX(0.5F);

        degreesInput.setToolTipText("Degrees");

        clearFieldsButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/nl/astron/lofar/sas/otb/icons/16_undo.png"))); // NOI18N
        clearFieldsButton.setText("Clear Fields");
        clearFieldsButton.setAlignmentX(0.5F);
        clearFieldsButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        clearFieldsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearFieldsButtonActionPerformed(evt);
            }
        });

        degreesDMSInput.setToolTipText("Hours in HMS notation");

        momIDLabel1.setText("Seconds:");
        momIDLabel1.setAlignmentX(0.5F);

        secondInput.setToolTipText("Seconds in HMS notation");

        jLabel2.setText("Degrees:");
        jLabel2.setAlignmentX(0.5F);

        convertFromInput.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "HMS", "DMS", "Radians", "Degrees" }));
        convertFromInput.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                convertFromInputActionPerformed(evt);
            }
        });

        jLabel4.setText("Convert from:");
        jLabel4.setAlignmentX(0.5F);

        hourInput.setToolTipText("Degrees in DMS notation");

        jLabel5.setText("Minutes:");
        jLabel5.setAlignmentX(0.5F);

        minuteDMSInput.setToolTipText("Minutes in HMS notation");

        momIDLabel2.setText("Seconds:");
        momIDLabel2.setAlignmentX(0.5F);

        secondDMSInput.setToolTipText("Seconds in HMS notation");

        jLabel7.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel7.setText("DMS");
        jLabel7.setAlignmentX(0.5F);

        jLabel8.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel8.setText("HMS");
        jLabel8.setAlignmentX(0.5F);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(jLabel4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 82, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(convertFromInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 200, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .addContainerGap()
                                .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 82, Short.MAX_VALUE))
                            .add(layout.createSequentialGroup()
                                .addContainerGap()
                                .add(jLabel10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(layout.createSequentialGroup()
                                .addContainerGap()
                                .add(jLabel6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 82, Short.MAX_VALUE))
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                        .addContainerGap()
                                        .add(momIDLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                        .addContainerGap()
                                        .add(jLabel5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                        .addContainerGap()
                                        .add(jLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                        .add(10, 10, 10)
                                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                            .add(jLabel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .add(momIDLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 72, Short.MAX_VALUE))))
                                .add(10, 10, 10)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(hourInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 200, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(minuteInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 200, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(secondInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 200, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(degreesDMSInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 200, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(minuteDMSInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 200, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(secondDMSInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 200, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(radianInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 200, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(degreesInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 200, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .add(105, 105, 105))
            .add(layout.createSequentialGroup()
                .add(10, 10, 10)
                .add(cancelButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 125, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(10, 10, 10)
                .add(clearFieldsButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 155, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(101, 101, 101))
            .add(layout.createSequentialGroup()
                .add(180, 180, 180)
                .add(jLabel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 120, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(101, 101, 101))
            .add(layout.createSequentialGroup()
                .add(180, 180, 180)
                .add(jLabel8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 120, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(101, 101, 101))
            .add(layout.createSequentialGroup()
                .add(139, 139, 139)
                .add(topLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 161, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(101, 101, 101))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(layout.createSequentialGroup()
                        .add(hourInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(minuteInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(10, 10, 10)
                        .add(secondInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(30, 30, 30)
                        .add(degreesDMSInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(10, 10, 10)
                        .add(minuteDMSInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(10, 10, 10)
                        .add(secondDMSInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(30, 30, 30)
                        .add(radianInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(20, 20, 20)
                        .add(degreesInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(topLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(9, 9, 9)
                                .add(jLabel8))
                            .add(layout.createSequentialGroup()
                                .add(54, 54, 54)
                                .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(10, 10, 10)
                        .add(momIDLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(10, 10, 10)
                        .add(jLabel7)
                        .add(6, 6, 6)
                        .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(10, 10, 10)
                        .add(jLabel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(10, 10, 10)
                        .add(momIDLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(30, 30, 30)
                        .add(jLabel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(20, 20, 20)
                        .add(jLabel10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(30, 30, 30)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(convertFromInput, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(80, 80, 80)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(cancelButton)
                    .add(clearFieldsButton))
                .addContainerGap(28, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents


    
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void clearFieldsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearFieldsButtonActionPerformed
    degreesDMSInput.setText("");
    minuteInput.setText("");
    secondInput.setText("");
    hourInput.setText("");
    minuteDMSInput.setText("");
    secondDMSInput.setText("");
    radianInput.setText("");
    degreesInput.setText("");
}//GEN-LAST:event_clearFieldsButtonActionPerformed

    private void convertFromInputActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_convertFromInputActionPerformed
        if (evt.getActionCommand().equals("comboBoxChanged")) {
            degreesDMSInput.setBackground(Color.white);
            minuteInput.setBackground(Color.white);
            secondInput.setBackground(Color.white);
            hourInput.setBackground(Color.white);
            minuteDMSInput.setBackground(Color.white);
            secondDMSInput.setBackground(Color.white);
            radianInput.setBackground(Color.white);
            degreesInput.setBackground(Color.white);
            String aS = convertFromInput.getSelectedItem().toString();
            boolean error=false;
            if (aS.contains("DMS")) {
                if (degreesDMSInput.getText().isEmpty()) {
                    degreesDMSInput.setBackground(Color.red);
                    error=true;
                }
                if (minuteDMSInput.getText().isEmpty()) {
                    minuteDMSInput.setBackground(Color.red);
                    error=true;
                }
                if (secondDMSInput.getText().isEmpty()) {
                    secondDMSInput.setBackground(Color.red);
                    error=true;
                }
                if (error) return;
                String dms=degreesDMSInput.getText()+":"+minuteDMSInput.getText()+":"+secondDMSInput.getText();
                try {
                    String hms = LofarUtils.dms2hms(dms);
                    double deg = LofarUtils.dms2deg(dms);
                    double rad = LofarUtils.dms2rad(dms);

                    // split HMS
                    String[] values = hms.split(":");
                    hourInput.setText(values[0]);
                    minuteInput.setText(values[1]);
                    secondInput.setText(values[2]);

                    radianInput.setText(String.valueOf(rad));
                    degreesInput.setText(String.valueOf(deg));

                } catch (NumberFormatException ex) {
                    degreesDMSInput.setBackground(Color.red);
                    minuteDMSInput.setBackground(Color.red);
                    secondDMSInput.setBackground(Color.red);
                } catch (ArrayIndexOutOfBoundsException ex) {
                    System.out.println("Error during split: "+ex);
                    degreesDMSInput.setBackground(Color.red);
                    minuteDMSInput.setBackground(Color.red);
                    secondDMSInput.setBackground(Color.red);
                }
            } else if (aS.contains("HMS")) {
                if (hourInput.getText().isEmpty()) {
                    hourInput.setBackground(Color.red);
                    error=true;
                }
                if (minuteInput.getText().isEmpty()) {
                    minuteInput.setBackground(Color.red);
                    error=true;
                }
                if (secondInput.getText().isEmpty()) {
                    secondInput.setBackground(Color.red);
                    error=true;
                }
                if (error) return;
                String hms=hourInput.getText()+":"+minuteInput.getText()+":"+secondInput.getText();
                try {
                    String dms = LofarUtils.hms2dms(hms);
                    double deg = LofarUtils.hms2deg(hms);
                    double rad = LofarUtils.hms2rad(hms);

                    // split DMS
                    String[] v1 = dms.split(":");
                    degreesDMSInput.setText(v1[0]);
                    minuteDMSInput.setText(v1[1]);
                    secondDMSInput.setText(v1[2]);

                    radianInput.setText(String.valueOf(rad));
                    degreesInput.setText(String.valueOf(deg));

                } catch (NumberFormatException ex) {
                    hourInput.setBackground(Color.red);
                    minuteInput.setBackground(Color.red);
                    secondInput.setBackground(Color.red);
                } catch (ArrayIndexOutOfBoundsException ex) {
                    System.out.println("Error during split: "+ex);
                    hourInput.setBackground(Color.red);
                    minuteInput.setBackground(Color.red);
                    secondInput.setBackground(Color.red);
                }
            } else if (aS.contains("Radians")) {
                if (radianInput.getText().isEmpty()) {
                    radianInput.setBackground(Color.red);
                    return;
                }
                try {
                    double rad = Double.valueOf(radianInput.getText());

                    String dms = LofarUtils.rad2dms(rad);
                    String hms = LofarUtils.rad2hms(rad);
                    double deg = LofarUtils.rad2deg(rad);

                    // split DMS
                    String[] v1 = dms.split(":");
                    degreesDMSInput.setText(v1[0]);
                    minuteDMSInput.setText(v1[1]);
                    secondDMSInput.setText(v1[2]);

                    // split HMS
                    String[] values = hms.split(":");
                    hourInput.setText(values[0]);
                    minuteInput.setText(values[1]);
                    secondInput.setText(values[2]);

                    degreesInput.setText(String.valueOf(deg));

                } catch (NumberFormatException ex) {
                    radianInput.setBackground(Color.red);
                } catch (ArrayIndexOutOfBoundsException ex) {
                    System.out.println("Error during split: "+ex);
                    radianInput.setBackground(Color.red);
                }
            } else if (aS.contains("Degrees")) {
                if (degreesInput.getText().isEmpty()) {
                    degreesInput.setBackground(Color.red);
                    return;
                }
                try {
                    double deg = Double.valueOf(degreesInput.getText());

                    String dms = LofarUtils.deg2dms(deg);
                    String hms = LofarUtils.deg2hms(deg);
                    double rad = LofarUtils.deg2rad(deg);

                    // split DMS
                    String[] v1 = dms.split(":");
                    degreesDMSInput.setText(v1[0]);
                    minuteDMSInput.setText(v1[1]);
                    secondDMSInput.setText(v1[2]);

                    // split HMS
                    String[] values = hms.split(":");
                    hourInput.setText(values[0]);
                    minuteInput.setText(values[1]);
                    secondInput.setText(values[2]);

                    radianInput.setText(String.valueOf(rad));

                } catch (NumberFormatException ex) {
                    degreesInput.setBackground(Color.red);
                } catch (ArrayIndexOutOfBoundsException ex) {
                    System.out.println("Error during split: "+ex);
                    degreesInput.setBackground(Color.red);
                }
            }
        }
}//GEN-LAST:event_convertFromInputActionPerformed


    private MainFrame itsMainFrame = null;
    private boolean   isInitialized=false;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton clearFieldsButton;
    private javax.swing.JComboBox convertFromInput;
    private javax.swing.JTextField degreesDMSInput;
    private javax.swing.JTextField degreesInput;
    private javax.swing.JTextField hourInput;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JTextField minuteDMSInput;
    private javax.swing.JTextField minuteInput;
    private javax.swing.JLabel momIDLabel1;
    private javax.swing.JLabel momIDLabel2;
    private javax.swing.JTextField radianInput;
    private javax.swing.JTextField secondDMSInput;
    private javax.swing.JTextField secondInput;
    private javax.swing.JTextArea topLabel;
    // End of variables declaration//GEN-END:variables

}
