/*
 * CoreStationLayout.java
 *
 * Created on 12 maart 2009, 12:21
 */

package nl.astron.lofar.sas.otbcomponents;

import java.awt.Color;
import java.awt.event.ActionEvent;
import org.apache.log4j.Logger;

/**
 *
 * @author  Coolen
 */
public class EuropeStationLayout extends javax.swing.JPanel {
    static Logger logger = Logger.getLogger(EuropeStationLayout.class);
    static String name="EuropeStationLayout";
    
    private boolean HBALeftSquareSelected=false;
    private boolean LBACircleSelected=false;

    /** Creates new form CoreStationLayout */
    public EuropeStationLayout() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        LBACircle = new nl.astron.lofar.sas.otbcomponents.RoundButton();
        LBACircle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ActionEvent event = new ActionEvent(this,-1,"LBACircle");
                fireActionListenerActionPerformed(event);  }
        });
        HBALeftSquare = new nl.astron.lofar.sas.otbcomponents.SquareButton();
        HBALeftSquare.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ActionEvent event = new ActionEvent(this,-1,"HBALeftSquare");
                fireActionListenerActionPerformed(event);
            }
        });

        setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Europe", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14))); // NOI18N
        setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        LBACircle.setText("96");
        LBACircle.setFont(new java.awt.Font("Dialog", 1, 12));
        add(LBACircle, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 50, 110, 110));

        HBALeftSquare.setText("96");
        HBALeftSquare.setEnabled(false);
        HBALeftSquare.setFont(new java.awt.Font("Dialog", 1, 12));
        add(HBALeftSquare, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 50, 110, 110));
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Notifies all registered listeners about the event.
     *
     * @param event The event to be fired
     */

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private nl.astron.lofar.sas.otbcomponents.SquareButton HBALeftSquare;
    private nl.astron.lofar.sas.otbcomponents.RoundButton LBACircle;
    // End of variables declaration//GEN-END:variables
    /**
     * Utility field used by event firing mechanism.
     */
    private javax.swing.event.EventListenerList myListenerList =  null;

    /**
     * Registers ActionListener to receive events.
     * @param listener The listener to register.
     */
    public synchronized void addActionListener(java.awt.event.ActionListener listener) {
        if (myListenerList == null ) {
            myListenerList = new javax.swing.event.EventListenerList();
        }
        myListenerList.add (java.awt.event.ActionListener.class, listener);
    }

    /**
     * Removes ActionListener from the list of listeners.
     * @param listener The listener to remove.
     */
    public synchronized void removeActionListener(java.awt.event.ActionListener listener) {
        myListenerList.remove (java.awt.event.ActionListener.class, listener);
    }


    /**
     * Notifies all registered listeners about the event.
     * 
     * @param event The event to be fired
     */
    private void fireActionListenerActionPerformed(java.awt.event.ActionEvent event) {

        if (myListenerList == null) return;
        Object[] listeners = myListenerList.getListenerList ();
        for (int i = listeners.length - 2; i >= 0; i -= 2) {
            if (listeners[i]==java.awt.event.ActionListener.class) {
                ((java.awt.event.ActionListener)listeners[i+1]).actionPerformed (event);
            }
        }
    }
    
    public boolean isHBALeftSquareEnabled() {
        return HBALeftSquare.isEnabled();
    }

    public void setHBALeftSquareEnabled(boolean b) {
        if (!b && HBALeftSquare.isSelected()) {
            setHBALeftSquareSelected(false);
        }
        HBALeftSquare.setEnabled(b);
        HBALeftSquare.invalidate();
        HBALeftSquare.repaint();
    }

    public boolean isLBACircleEnabled() {
        return LBACircle.isEnabled();
    }

    public void setLBACircleEnabled(boolean b) {
        if (!b && LBACircle.isSelected()) {
            setLBACircleSelected(false);
        }
        LBACircle.setEnabled(b);
        LBACircle.invalidate();
        LBACircle.repaint();
    }
    
    public boolean isHBALeftSquareSelected() {
        return HBALeftSquareSelected;
    }

    public void setHBALeftSquareSelected(boolean b) {
        HBALeftSquareSelected=b;
        if (b) {
            HBALeftSquare.setBackground(Color.green);
        } else {
            HBALeftSquare.setBackground(getBackground());
        }
        HBALeftSquare.invalidate();
        HBALeftSquare.repaint();
    }

    public boolean isLBACircleSelected() {
        return LBACircleSelected;
    }

    public void setLBACircleSelected(boolean b) {
        LBACircleSelected=b;
        if (b) {
            LBACircle.setBackground(Color.green);
        } else {
            LBACircle.setBackground(getBackground());
        }
        LBACircle.invalidate();
        LBACircle.repaint();
    }
}


