# Create your models here.

from django.db.models import TextField, IntegerField,BooleanField, ForeignKey, CASCADE, Model,NullBooleanField
from viewflow.models import Process, Task
from viewflow.fields import FlowReferenceField
from viewflow.compat import _

from lofar.sas.tmss.tmss.tmssapp.models import SchedulingUnitBlueprint


class QAReportingTO(Model):
    operator_report = TextField()
    operator_accept = BooleanField(default=False)


class QAReportingSOS(Model):
    sos_report = TextField()
    quality_within_policy = BooleanField(default=False)
    sos_accept_show_pi = BooleanField(default=False)


class PIVerification(Model):
    pi_report = TextField()
    pi_accept = BooleanField(default=False)


class DecideAcceptance(Model):
    sos_accept_after_pi = BooleanField(default=False)

class UnpinData(Model):
    unpin_data = BooleanField(default=False)

class SchedulingUnitProcess(Process):
    su = ForeignKey(SchedulingUnitBlueprint, blank=True, null=True, on_delete=CASCADE)
    qa_reporting_to=ForeignKey(QAReportingTO, blank=True, null=True, on_delete=CASCADE)
    qa_reporting_sos=ForeignKey(QAReportingSOS, blank=True, null=True, on_delete=CASCADE)
    pi_verification=ForeignKey(PIVerification, blank=True, null=True, on_delete=CASCADE)
    decide_acceptance=ForeignKey(DecideAcceptance, blank=True, null=True, on_delete=CASCADE)

