from rest_framework.serializers import ModelSerializer
from lofar.sas.tmss.tmss.workflowapp import models

from django.views import generic
from django.forms.models import modelform_factory

from viewflow.models import Task


from .. import forms

#Viewsets and serializers to access intermediate steps of the QA Workflow
#through DRF
class QAReportingTOSerializer(ModelSerializer):
  class Meta:
    model = models.QAReportingTO
    fields = '__all__'
  
class QAReportingSOSSerializer(ModelSerializer):
  class Meta:
    model = models.QAReportingSOS
    fields = '__all__'

class PIVerificationSerializer(ModelSerializer):
  class Meta:
    model = models.PIVerification
    fields = '__all__'

class DecideAcceptanceSerializer(ModelSerializer):
  class Meta:
    model = models.DecideAcceptance
    fields = '__all__'

class SchedulingUnitProcessSerializer(ModelSerializer):
  class Meta:
      model = models.SchedulingUnitProcess
      fields = '__all__'
      
class SchedulingUnitTaskSerializer(ModelSerializer):
  class Meta:
      model = Task
      fields = '__all__'

class SchedulingUnitAssignTaskSerializer(ModelSerializer):
  class Meta:
      model = Task
      fields = ['id','owner']

class SchedulingUnitUnassignTaskSerializer(ModelSerializer):
  class Meta:
      model = Task
      fields = ['id']

class SchedulingUnitGetActiveTasksSerializer(ModelSerializer):
  class Meta:
      model = models.SchedulingUnitProcess
      fields = ['id']

      